Index: /palm/trunk/SOURCE/salsa_mod.f90
===================================================================
--- /palm/trunk/SOURCE/salsa_mod.f90	(revision 3863)
+++ /palm/trunk/SOURCE/salsa_mod.f90	(revision 3864)
@@ -3943,117 +4146,114 @@
 !
 !--    5.1.1) Non-volatile organic compound: condenses onto all bins
-       IF ( pcocnv > 1.0E+10_wp  .AND.  zcs_tot > 1.0E-30_wp  .AND.            &
-            is_used( prtcl,'OC' ) )                                            &
+       IF ( pc_ocnv > 1.0E+10_wp  .AND.  zcs_tot > 1.0E-30_wp  .AND. index_oc > 0 )  &
        THEN
-!--       Ratio of nucleation vs. condensation rates in the smallest bin    
-          zn_vs_c = 0.0_wp  
+!--       Ratio of nucleation vs. condensation rates in the smallest bin
+          zn_vs_c = 0.0_wp
           IF ( zj3n3(2) > 1.0_wp )  THEN
-             zn_vs_c = ( zj3n3(2) ) / ( zj3n3(2) + pcocnv * zcolrate(in1a) )
+             zn_vs_c = ( zj3n3(2) ) / ( zj3n3(2) + pc_ocnv * zcolrate(start_subrange_1a) )
           ENDIF
-!       
-!--       Collision rate in the smallest bin, including nucleation and 
-!--       condensation(see Jacobson, Fundamentals of Atmospheric Modeling, 2nd 
-!--       Edition (2005), equation (16.73) )
+!
+!--       Collision rate in the smallest bin, including nucleation and condensation (see
+!--       Jacobson (2005), eq. (16.73) )
           zcolrate_ocnv = zcolrate
-          zcolrate_ocnv(in1a) = zcolrate_ocnv(in1a) + zj3n3(2) / pcocnv
-!       
+          zcolrate_ocnv(start_subrange_1a) = zcolrate_ocnv(start_subrange_1a) + zj3n3(2) / pc_ocnv
+!
 !--       Total sink for organic vapor
-          zcs_ocnv = zcs_tot + zj3n3(2) / pcocnv
-!       
+          zcs_ocnv = zcs_tot + zj3n3(2) / pc_ocnv
+!
 !--       New gas phase concentration (#/m3)
-          zcvap_new2 = pcocnv / ( 1.0_wp + ptstep * zcs_ocnv )
-!       
+          zcvap_new2 = pc_ocnv / ( 1.0_wp + ptstep * zcs_ocnv )
+!
 !--       Change in gas concentration (#/m3)
-          zdvap2 = pcocnv - zcvap_new2
-!
-!--       Updated vapour concentration (#/m3)                
-          pcocnv = zcvap_new2
-!       
+          zdvap2 = pc_ocnv - zcvap_new2
+!
+!--       Updated vapour concentration (#/m3)
+          pc_ocnv = zcvap_new2
+!
 !--       Volume change of particles (m3(OC)/m3(air))
-          zdvoloc = zcolrate_ocnv(in1a:fn2b) / zcs_ocnv * amvoc * zdvap2
-!       
+          zdvoloc = zcolrate_ocnv(start_subrange_1a:end_subrange_2b) / zcs_ocnv * amvoc * zdvap2
+!
 !--       Change of volume due to condensation in 1a-2b
-          paero(in1a:fn2b)%volc(2) = paero(in1a:fn2b)%volc(2) + zdvoloc  
-!       
-!--       Change of number concentration in the smallest bin caused by 
-!--       nucleation (Jacobson (2005), equation (16.75)). If zxocnv = 0, then  
-!--       the chosen nucleation mechanism doesn't take into account the non-
-!--       volatile organic vapors and thus the paero doesn't have to be updated.
+          paero(start_subrange_1a:end_subrange_2b)%volc(2) =                                       &
+                                          paero(start_subrange_1a:end_subrange_2b)%volc(2) + zdvoloc
+!
+!--       Change of number concentration in the smallest bin caused by nucleation (Jacobson (2005),
+!--       eq. (16.75)). If zxocnv = 0, then the chosen nucleation mechanism doesn't take into
+!--       account the non-volatile organic vapors and thus the paero doesn't have to be updated.
           IF ( zxocnv > 0.0_wp )  THEN
-             paero(in1a)%numc = paero(in1a)%numc + zn_vs_c * zdvoloc(in1a) /   &
-                                amvoc / ( n3 * zxocnv )
+             paero(start_subrange_1a)%numc = paero(start_subrange_1a)%numc + zn_vs_c *             &
+                                             zdvoloc(start_subrange_1a) / amvoc / ( n3 * zxocnv )
           ENDIF
        ENDIF
-!    
+!
 !--    5.1.2) Semivolatile organic compound: all bins except subrange 1
-       zcs_ocsv = SUM( zcolrate(in2a:fn2b) ) !< sink for semi-volatile organics
-       IF ( pcocsv > 1.0E+10_wp  .AND.  zcs_ocsv > 1.0E-30  .AND.              &
-            is_used( prtcl,'OC') )                                             &
-       THEN
+       zcs_ocsv = SUM( zcolrate(start_subrange_2a:end_subrange_2b) ) !< sink for semi-volatile organics
+       IF ( pcocsv > 1.0E+10_wp  .AND.  zcs_ocsv > 1.0E-30  .AND. is_used( prtcl,'OC') )  THEN
 !
 !--       New gas phase concentration (#/m3)
           zcvap_new3 = pcocsv / ( 1.0_wp + ptstep * zcs_ocsv )
-!       
+!
 !--       Change in gas concentration (#/m3)
           zdvap3 = pcocsv - zcvap_new3 
-!       
-!--       Updated gas concentration (#/m3)                
+!
+!--       Updated gas concentration (#/m3)
           pcocsv = zcvap_new3
-!       
+!
 !--       Volume change of particles (m3(OC)/m3(air))
-          zdvoloc(in2a:fn2b) = zdvoloc(in2a:fn2b) + zcolrate(in2a:fn2b) /      &
-                               zcs_ocsv * amvoc * zdvap3
-!                            
+          ss = start_subrange_2a
+          ee = end_subrange_2b
+          zdvoloc(ss:ee) = zdvoloc(ss:ee) + zcolrate(ss:ee) / zcs_ocsv * amvoc * zdvap3
+!
 !--       Change of volume due to condensation in 1a-2b
-          paero(in1a:fn2b)%volc(2) = paero(in1a:fn2b)%volc(2) + zdvoloc 
-       ENDIF
-!
-!-- 5.2) Sulphate: condensed on all bins
-       IF ( pcsa > 1.0E+10_wp  .AND.  zcs_tot > 1.0E-30_wp  .AND.              &
-            is_used( prtcl,'SO4' ) )                                           &
-       THEN
-!    
+          paero(start_subrange_1a:end_subrange_2b)%volc(2) =                                       &
+                                          paero(start_subrange_1a:end_subrange_2b)%volc(2) + zdvoloc
+       ENDIF
+!
+!--    5.2) Sulphate: condensed on all bins
+       IF ( pc_sa > 1.0E+10_wp  .AND.  zcs_tot > 1.0E-30_wp  .AND.  index_so4 > 0 )  THEN
+!
 !--    Ratio of mass transfer between nucleation and condensation
           zn_vs_c = 0.0_wp
           IF ( zj3n3(1) > 1.0_wp )  THEN
-             zn_vs_c = ( zj3n3(1) ) / ( zj3n3(1) + pcsa * zcolrate(in1a) )
+             zn_vs_c = ( zj3n3(1) ) / ( zj3n3(1) + pc_sa * zcolrate(start_subrange_1a) )
           ENDIF
-!       
-!--       Collision rate in the smallest bin, including nucleation and 
-!--       condensation (see Jacobson, Fundamentals of Atmospheric Modeling, 2nd 
-!--       Edition (2005), equation (16.73))
-          zcolrate(in1a) = zcolrate(in1a) + zj3n3(1) / pcsa     
-!       
+!
+!--       Collision rate in the smallest bin, including nucleation and condensation (see
+!--       Jacobson (2005), eq. (16.73))
+          zcolrate(start_subrange_1a) = zcolrate(start_subrange_1a) + zj3n3(1) / pc_sa
+!
 !--       Total sink for sulfate (1/s)
-          zcs_su = zcs_tot + zj3n3(1) / pcsa
-!       
+          zcs_su = zcs_tot + zj3n3(1) / pc_sa
+!
 !--       Sulphuric acid:
 !--       New gas phase concentration (#/m3)
-          zcvap_new1 = pcsa / ( 1.0_wp + ptstep * zcs_su )
-!       
+          zcvap_new1 = pc_sa / ( 1.0_wp + ptstep * zcs_su )
+!
 !--       Change in gas concentration (#/m3)
-          zdvap1 = pcsa - zcvap_new1
-!       
+          zdvap1 = pc_sa - zcvap_new1
+!
 !--       Updating vapour concentration (#/m3)
-          pcsa = zcvap_new1
-!       
+          pc_sa = zcvap_new1
+!
 !--       Volume change of particles (m3(SO4)/m3(air)) by condensation
-          zdvolsa = zcolrate(in1a:fn2b) / zcs_su * amvh2so4 * zdvap1
-!--       For validation: zdvolsa = 5.5 mum3/cm3 per 12 h       
-       !   zdvolsa = zdvolsa / SUM( zdvolsa ) * 5.5E-12_wp * dt_salsa / 43200.0_wp  
-          !0.3E-12_wp, 0.6E-12_wp, 11.0E-12_wp, 4.6E-12_wp, 9.2E-12_wp    
-!       
+          zdvolsa = zcolrate(start_subrange_1a:end_subrange_2b) / zcs_su * amvh2so4 * zdvap1
+!
 !--       Change of volume concentration of sulphate in aerosol [fxm]
-          paero(in1a:fn2b)%volc(1) = paero(in1a:fn2b)%volc(1) + zdvolsa
-!       
+          paero(start_subrange_1a:end_subrange_2b)%volc(1) =                                       &
+                                          paero(start_subrange_1a:end_subrange_2b)%volc(1) + zdvolsa
+!
 !--       Change of number concentration in the smallest bin caused by nucleation
 !--       (Jacobson (2005), equation (16.75))
           IF ( zxsa > 0.0_wp )  THEN
-             paero(in1a)%numc = paero(in1a)%numc + zn_vs_c * zdvolsa(in1a) /   &
-                                amvh2so4 / ( n3 * zxsa )
+             paero(start_subrange_1a)%numc = paero(start_subrange_1a)%numc + zn_vs_c *             &
+                                             zdvolsa(start_subrange_1a) / amvh2so4 / ( n3 * zxsa)
           ENDIF
        ENDIF
+!
+!--    Partitioning of H2O, HNO3, and NH3: Dissolutional growth
+       IF ( lspartition  .AND.  ( pchno3 > 1.0E+10_wp  .OR.  pc_nh3 > 1.0E+10_wp ) )  THEN
+          CALL gpparthno3( ppres, ptemp, paero, pchno3, pc_nh3, pcw, pcs, zbeta, ptstep )
+       ENDIF
     ENDIF
-!
 !
 !-- Condensation of water vapour
@@ -4061,16 +4261,7 @@
        CALL gpparth2o( paero, ptemp, ppres, pcs, pcw, ptstep )
     ENDIF
-!   
-!
-!-- Partitioning of H2O, HNO3, and NH3: Dissolutional growth
-    IF ( lscndgas  .AND.  ino > 0  .AND.  inh > 0  .AND.                       &
-         ( pchno3 > 1.0E+10_wp  .OR.  pcnh3 > 1.0E+10_wp ) )                   &
-    THEN
-       CALL gpparthno3( ppres, ptemp, paero, pchno3, pcnh3, pcw, pcs, zbeta,   &
-                        ptstep )
-    ENDIF
-    
+
  END SUBROUTINE condensation
- 
+
 !------------------------------------------------------------------------------!
 ! Description:
@@ -4091,4 +4282,8 @@
 !> nj3 = 3: Anttila et al. (2010), J. Aerosol Sci., 41(7), 621-636.
 !
+!> c = aerosol of critical radius (1 nm)
+!> x = aerosol with radius 3 nm
+!> 2 = wet or mean droplet
+!
 !> Called from subroutine condensation (in module salsa_dynamics_mod.f90)
 !
@@ -4109,97 +4304,96 @@
 !------------------------------------------------------------------------------!
 
- SUBROUTINE nucleation( paero, ptemp, prh, ppres, pcsa, pcocnv, pcnh3, ptstep, &
-                        pj3n3, pxsa, pxocnv )
+ SUBROUTINE nucleation( paero, ptemp, prh, ppres, pc_sa, pc_ocnv, pc_nh3, ptstep, pj3n3, pxsa,     &
+                        pxocnv )
+
     IMPLICIT NONE
-!       
-!-- Input and output variables
-    REAL(wp), INTENT(in) ::  pcnh3    !< ammonia concentration (#/m3) 
-    REAL(wp), INTENT(in) ::  pcocnv   !< conc. of non-volatile OC (#/m3)      
-    REAL(wp), INTENT(in) ::  pcsa     !< sulphuric acid conc. (#/m3)
+
+    INTEGER(iwp) ::  iteration
+
+    REAL(wp) ::  zc_h2so4     !< H2SO4 conc. (#/cm3) !UNITS!
+    REAL(wp) ::  zc_org       !< organic vapour conc. (#/cm3)
+    REAL(wp) ::  zcc_c        !< Cunningham correct factor for c = critical (1nm)
+    REAL(wp) ::  zcc_x        !< Cunningham correct factor for x = 3nm
+    REAL(wp) ::  zcoags_c     !< coagulation sink (1/s) for c = critical (1nm)
+    REAL(wp) ::  zcoags_x     !< coagulation sink (1/s) for x = 3nm
+    REAL(wp) ::  zcoagstot    !< total particle losses due to coagulation, including condensation
+                              !< and self-coagulation
+    REAL(wp) ::  zcocnv_local !< organic vapour conc. (#/m3)
+    REAL(wp) ::  zcsink       !< condensational sink (#/m2)
+    REAL(wp) ::  zcsa_local   !< H2SO4 conc. (#/m3)
+    REAL(wp) ::  zcv_c        !< mean relative thermal velocity (m/s) for c = critical (1nm)
+    REAL(wp) ::  zcv_x        !< mean relative thermal velocity (m/s) for x = 3nm
+    REAL(wp) ::  zdcrit       !< diameter of critical cluster (m)
+    REAL(wp) ::  zdelta_vap   !< change of H2SO4 and organic vapour concentration (#/m3)
+    REAL(wp) ::  zdfvap       !< air diffusion coefficient (m2/s)
+    REAL(wp) ::  zdmean       !< mean diameter of existing particles (m) 
+    REAL(wp) ::  zeta         !< constant: proportional to ratio of CS/GR (m)
+                              !< (condensation sink / growth rate)
+    REAL(wp) ::  zgamma       !< proportionality factor ((nm2*m2)/h)
+    REAL(wp) ::  z_gr_clust   !< growth rate of formed clusters (nm/h)
+    REAL(wp) ::  z_gr_tot     !< total growth rate
+    REAL(wp) ::  zj3          !< number conc. of formed 3nm particles (#/m3)
+    REAL(wp) ::  zjnuc        !< nucleation rate at ~1nm (#/m3s)
+    REAL(wp) ::  z_k_eff      !< effective cogulation coefficient for freshly nucleated particles
+    REAL(wp) ::  zknud_c      !< Knudsen number for c = critical (1nm)
+    REAL(wp) ::  zknud_x      !< Knudsen number for x = 3nm
+    REAL(wp) ::  zkocnv       !< lever: zkocnv=1 --> organic compounds involved in nucleation
+    REAL(wp) ::  zksa         !< lever: zksa=1 --> H2SO4 involved in nucleation
+    REAL(wp) ::  zlambda      !< parameter for adjusting the growth rate due to self-coagulation
+    REAL(wp) ::  zm_c         !< particle mass (kg) for c = critical (1nm)
+    REAL(wp) ::  zm_para      !< Parameter m for calculating the coagulation sink (Eq. 5&6 in 
+                              !< Lehtinen et al. 2007)
+    REAL(wp) ::  zm_x         !< particle mass (kg) for x = 3nm
+    REAL(wp) ::  zmfp         !< mean free path of condesing vapour(m)
+    REAL(wp) ::  zmixnh3      !< ammonia mixing ratio (ppt)
+    REAL(wp) ::  zmyy         !< gas dynamic viscosity (N*s/m2)
+    REAL(wp) ::  z_n_nuc      !< number of clusters/particles at the size range d1-dx (#/m3)
+    REAL(wp) ::  znoc         !< number of organic molecules in critical cluster
+    REAL(wp) ::  znsa         !< number of H2SO4 molecules in critical cluster
+
+    REAL(wp), INTENT(in) ::  pc_nh3   !< ammonia concentration (#/m3) 
+    REAL(wp), INTENT(in) ::  pc_ocnv  !< conc. of non-volatile OC (#/m3)
+    REAL(wp), INTENT(in) ::  pc_sa    !< sulphuric acid conc. (#/m3)
     REAL(wp), INTENT(in) ::  ppres    !< ambient air pressure (Pa)
-    REAL(wp), INTENT(in) ::  prh      !< ambient rel. humidity [0-1]       
+    REAL(wp), INTENT(in) ::  prh      !< ambient rel. humidity [0-1]
     REAL(wp), INTENT(in) ::  ptemp    !< ambient temperature (K)
     REAL(wp), INTENT(in) ::  ptstep   !< time step (s) of SALSA
-    TYPE(t_section), INTENT(inout) ::  paero(fn2b) !< aerosol properties                                                  
-    REAL(wp), INTENT(inout) ::  pj3n3(2) !< formation mass rate of molecules 
-                                         !< (molec/m3s) for 1: H2SO4 and 
-                                         !< 2: organic vapour 
-    REAL(wp), INTENT(out) ::  pxocnv !< ratio of non-volatile organic vapours in
-                                     !< 3nm aerosol particles
-    REAL(wp), INTENT(out) ::  pxsa   !< ratio of H2SO4 in 3nm aerosol particles
-!-- Local variables
-    INTEGER(iwp) ::  iteration
-    REAL(wp) ::  zbeta(fn2b)  !< transitional correction factor                                         
-    REAL(wp) ::  zc_h2so4     !< H2SO4 conc. (#/cm3) !UNITS!
-    REAL(wp) ::  zc_org       !< organic vapour conc. (#/cm3)
-    REAL(wp) ::  zCoagStot    !< total losses due to coagulation, including 
-                              !< condensation and self-coagulation       
-    REAL(wp) ::  zcocnv_local !< organic vapour conc. (#/m3) 
-    REAL(wp) ::  zcsink       !< condensational sink (#/m2)       
-    REAL(wp) ::  zcsa_local   !< H2SO4 conc. (#/m3)       
-    REAL(wp) ::  zdcrit       !< diameter of critical cluster (m)
-    REAL(wp) ::  zdelta_vap   !< change of H2SO4 and organic vapour
-                              !< concentration (#/m3)       
-    REAL(wp) ::  zdfvap       !< air diffusion coefficient (m2/s)
-    REAL(wp) ::  zdmean       !< mean diameter of existing particles (m) 
-    REAL(wp) ::  zeta         !< constant: proportional to ratio of CS/GR (m) 
-                              !< (condensation sink / growth rate)                                   
-    REAL(wp) ::  zgamma       !< proportionality factor ((nm2*m2)/h)                                        
-    REAL(wp) ::  zGRclust     !< growth rate of formed clusters (nm/h)
-    REAL(wp) ::  zGRtot       !< total growth rate        
-    REAL(wp) ::  zj3          !< number conc. of formed 3nm particles (#/m3)       
-    REAL(wp) ::  zjnuc        !< nucleation rate at ~1nm (#/m3s)
-    REAL(wp) ::  zKeff        !< effective cogulation coefficient between 
-                              !< freshly nucleated particles       
-    REAL(wp) ::  zknud(fn2b)  !< particle Knudsen number       
-    REAL(wp) ::  zkocnv       !< lever: zkocnv=1 --> organic compounds involved
-                              !< in nucleation    
-    REAL(wp) ::  zksa         !< lever: zksa=1 --> H2SO4 involved in nucleation 
-    REAL(wp) ::  zlambda      !< parameter for adjusting the growth rate due to 
-                              !< self-coagulation                                  
-    REAL(wp) ::  zmfp         !< mean free path of condesing vapour(m)                                        
-    REAL(wp) ::  zmixnh3      !< ammonia mixing ratio (ppt)
-    REAL(wp) ::  zNnuc        !< number of clusters/particles at the size range
-                              !< d1-dx (#/m3)  
-    REAL(wp) ::  znoc         !< number of organic molecules in critical cluster
-    REAL(wp) ::  znsa         !< number of H2SO4 molecules in critical cluster                                           
-!
-!-- Variable determined for the m-parameter
-    REAL(wp) ::  zCc_2(fn2b) !<
-    REAL(wp) ::  zCc_c !<
-    REAL(wp) ::  zCc_x !<
-    REAL(wp) ::  zCoagS_c !<
-    REAL(wp) ::  zCoagS_x !<
-    REAL(wp) ::  zcv_2(fn2b) !<
-    REAL(wp) ::  zcv_c !<
-    REAL(wp) ::  zcv_c2(fn2b) !<
-    REAL(wp) ::  zcv_x !<
-    REAL(wp) ::  zcv_x2(fn2b) !<
-    REAL(wp) ::  zDc_2(fn2b) !<
-    REAL(wp) ::  zDc_c(fn2b) !<
-    REAL(wp) ::  zDc_c2(fn2b) !<
-    REAL(wp) ::  zDc_x(fn2b) !<
-    REAL(wp) ::  zDc_x2(fn2b) !<
-    REAL(wp) ::  zgammaF_2(fn2b) !<
-    REAL(wp) ::  zgammaF_c(fn2b) !<
-    REAL(wp) ::  zgammaF_x(fn2b) !<
-    REAL(wp) ::  zK_c2(fn2b) !<
-    REAL(wp) ::  zK_x2(fn2b) !<
-    REAL(wp) ::  zknud_2(fn2b) !<
-    REAL(wp) ::  zknud_c !<
-    REAL(wp) ::  zknud_x !<       
-    REAL(wp) ::  zm_2(fn2b) !<
-    REAL(wp) ::  zm_c !<
-    REAL(wp) ::  zm_para !<
-    REAL(wp) ::  zm_x !<
-    REAL(wp) ::  zmyy !<
-    REAL(wp) ::  zomega_2c(fn2b) !<
-    REAL(wp) ::  zomega_2x(fn2b) !<
-    REAL(wp) ::  zomega_c(fn2b) !<
-    REAL(wp) ::  zomega_x(fn2b) !<
-    REAL(wp) ::  zRc2(fn2b) !<
-    REAL(wp) ::  zRx2(fn2b) !<
-    REAL(wp) ::  zsigma_c2(fn2b) !<
-    REAL(wp) ::  zsigma_x2(fn2b) !<
+
+    REAL(wp), INTENT(inout) ::  pj3n3(2) !< formation mass rate of molecules (molec/m3s) for
+                                         !< 1: H2SO4 and 2: organic vapour
+
+    REAL(wp), INTENT(out) ::  pxocnv  !< ratio of non-volatile organic vapours in 3 nm particles
+    REAL(wp), INTENT(out) ::  pxsa    !< ratio of H2SO4 in 3 nm aerosol particles
+
+    REAL(wp), DIMENSION(nbins_aerosol) ::  zbeta       !< transitional correction factor
+    REAL(wp), DIMENSION(nbins_aerosol) ::  zcc_2       !< Cunningham correct factor:2
+    REAL(wp), DIMENSION(nbins_aerosol) ::  zcv_2       !< mean relative thermal velocity (m/s): 2
+    REAL(wp), DIMENSION(nbins_aerosol) ::  zcv_c2      !< average velocity after coagulation: c & 2
+    REAL(wp), DIMENSION(nbins_aerosol) ::  zcv_x2      !< average velocity after coagulation: x & 2
+    REAL(wp), DIMENSION(nbins_aerosol) ::  zdc_2       !< particle diffusion coefficient (m2/s): 2
+    REAL(wp), DIMENSION(nbins_aerosol) ::  zdc_c       !< particle diffusion coefficient (m2/s): c
+    REAL(wp), DIMENSION(nbins_aerosol) ::  zdc_c2      !< sum of diffusion coef. for c and 2
+    REAL(wp), DIMENSION(nbins_aerosol) ::  zdc_x       !< particle diffusion coefficient (m2/s): x
+    REAL(wp), DIMENSION(nbins_aerosol) ::  zdc_x2      !< sum of diffusion coef. for: x & 2
+    REAL(wp), DIMENSION(nbins_aerosol) ::  zgamma_f_2  !< zgamma_f for calculating zomega
+    REAL(wp), DIMENSION(nbins_aerosol) ::  zgamma_f_c  !< zgamma_f for calculating zomega
+    REAL(wp), DIMENSION(nbins_aerosol) ::  zgamma_f_x  !< zgamma_f for calculating zomega
+    REAL(wp), DIMENSION(nbins_aerosol) ::  z_k_c2      !< coagulation coef. in the continuum
+                                                       !< regime: c & 2
+    REAL(wp), DIMENSION(nbins_aerosol) ::  z_k_x2      !< coagulation coef. in the continuum
+                                                       !< regime: x & 2
+    REAL(wp), DIMENSION(nbins_aerosol) ::  zknud       !< particle Knudsen number
+    REAL(wp), DIMENSION(nbins_aerosol) ::  zknud_2     !< particle Knudsen number: 2
+    REAL(wp), DIMENSION(nbins_aerosol) ::  zm_2        !< particle mass (kg): 2
+    REAL(wp), DIMENSION(nbins_aerosol) ::  zomega_2c   !< zomega (m) for calculating zsigma: c & 2
+    REAL(wp), DIMENSION(nbins_aerosol) ::  zomega_2x   !< zomega (m) for calculating zsigma: x & 2
+    REAL(wp), DIMENSION(nbins_aerosol) ::  zomega_c    !< zomega (m) for calculating zsigma: c
+    REAL(wp), DIMENSION(nbins_aerosol) ::  zomega_x    !< zomega (m) for calculating zsigma: x
+    REAL(wp), DIMENSION(nbins_aerosol) ::  z_r_c2      !< sum of the radii: c & 2
+    REAL(wp), DIMENSION(nbins_aerosol) ::  z_r_x2      !< sum of the radii: x & 2
+    REAL(wp), DIMENSION(nbins_aerosol) ::  zsigma_c2   !<
+    REAL(wp), DIMENSION(nbins_aerosol) ::  zsigma_x2   !<
+
+    TYPE(t_section), DIMENSION(nbins_aerosol), INTENT(inout) ::  paero  !< aerosol properties
 !
 !-- 1) Nucleation rate (zjnuc) and diameter of critical cluster (zdcrit)
